; ..............................................................................
;    File   filter.s
; ..............................................................................

		.equ filterNumTaps, 64

; ..............................................................................
; Allocate and initialize filter taps

		.section .xdata
		.align 128

filterTaps:
.hword 	0x0000,	0xFFFE,	0xFFFA,	0xFFF3,	0xFFE9,	0xFFD8,	0xFFC2,	0xFFA4,	0xFF80
.hword 	0xFF54,	0xFF24,	0xFEF2,	0xFEC1,	0xFE97,	0xFE7A,	0xFE70,	0xFE80,	0xFEB0
.hword 	0xFF05,	0xFF83,	0x0029,	0x00F9,	0x01ED,	0x02FE,	0x0422,	0x054E,	0x0673
.hword 	0x0783,	0x0872,	0x0931,	0x09B7,	0x09FB,	0x09FB,	0x09B7,	0x0931,	0x0872
.hword 	0x0783,	0x0673,	0x054E,	0x0422,	0x02FE,	0x01ED,	0x00F9,	0x0029,	0xFF83
.hword 	0xFF05,	0xFEB0,	0xFE80,	0xFE70,	0xFE7A,	0xFE97,	0xFEC1,	0xFEF2,	0xFF24
.hword 	0xFF54,	0xFF80,	0xFFA4,	0xFFC2,	0xFFD8,	0xFFE9,	0xFFF3,	0xFFFA,	0xFFFE
.hword 	0x0000

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss,  "b"
		.align 128

filterDelay:
		.space filterNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _filterFilter

_filterFilter:
.hword filterNumTaps
.hword filterTaps
.hword filterTaps+filterNumTaps*2-1
.hword 0xff00
.hword filterDelay
.hword filterDelay+filterNumTaps*2-1
.hword filterDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_BlockFIRFilter
;		.extern	_filterFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 4)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_filterFilter, W0	; Initalize W0 to filter structure
;		call	_FIRFilterInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _BlockFIRFilter
;		mov	#_filterFilter, W0	; Initalize W0 to filter structure
;		mov	#input, W1	; Initalize W1 to input buffer 
;		mov	#output, W2	; Initalize W2 to output buffer
;		mov	#20, W3	; Initialize W3 with number of required output samples
;		call	_BlockFIRFilter	; call as many times as needed
