#include "p33fxxxx.h"
#include "dsp.h"
#include <delay.h>
#include "..\h\table.h"

void initS2P()
{
	TRISA = 0x00;  // init all of A register as outputs
	TRISB = 0x00;  // init all of B register as ouputs
				   // NOTE: B encompasses most of the GPIO pins
				   // DAC, ADC, and others use some but this doesn't interfere
}

void clockSR()
{
	PORTBbits.RB4 = 1;
	PORTBbits.RB4 = 0;
}

void updateLEDArray(int shift[25])
{
	int bitNum;

	for(bitNum = 24; bitNum > -1; bitNum--)
	{
		PORTAbits.RA3 = shift[bitNum]; // put bit on SER
		clockSR();               	   // clock SRCLK
	}
	// clockSR();          // an addl clock is necessary... for some reason.
	PORTAbits.RA4 = 1;  // clock REGCLK
	PORTAbits.RA4 = 0;  // BRIGHT LIGHTS WOOT! (in theory)
}

void clearDisplay()
{
	int bitArray[25];

	bitArray[0]  = 0; // Qa1
	bitArray[1]  = 0; // Qb1
	bitArray[2]  = 0; // Qc1
	bitArray[3]  = 0; // Qd1
	bitArray[4]  = 0; // Qe1
	bitArray[5]  = 0; // Qf1
	bitArray[6]  = 0; // Qg1
	bitArray[7]  = 0; // Qh1
	bitArray[8]  = 0; // Qa2
	bitArray[9]  = 0; // Qb2
	bitArray[10] = 0; // Qc3
	bitArray[11] = 0; // Qd2
	bitArray[12] = 0; // Qe2
	bitArray[13] = 0; // Qf2
	bitArray[14] = 0; // Qg2
	bitArray[15] = 0; // Qh2
	bitArray[16] = 0; // Qa3
	bitArray[17] = 0; // Qb3
	bitArray[18] = 0; // Qc3
	bitArray[19] = 0; // Qd3
	bitArray[20] = 0; // Qe3
	bitArray[21] = 0; // Qf3
	bitArray[22] = 0; // Qg3
	bitArray[23] = 0; // Qh3
	bitArray[24] = 0; // Qa4
	updateLEDArray(bitArray);
}

void testAllLights(){

	clearDisplay();

	int bitArray[25];

	bitArray[1] = 1;
	updateLEDArray(bitArray);

	int i;
	for(i = 1; i < 25; i++)
	{
		bitArray[i-1] = 0;
		bitArray[i] = 1;
		updateLEDArray(bitArray);
		Delay(45);
	}
	
}

void fullDisplayFlash(){
	int bitArray[25];

	int i;
	for(i = 0; i < 25; i++)
	{
		bitArray[i]  = 1;
	}

	updateLEDArray(bitArray);
	Delay(100);

	for(i = 0; i < 25; i++)
	{
		bitArray[i]  = 0;
	}
	updateLEDArray(bitArray);
	Delay(100);
}
